# -*- coding:utf-8 -*-
# Author: Bingning Wang (王炳宁)
# Email: research@bingning.wang
# HomePage: www.bingning.wang
# Date: 2017/6/1 0001 上午 12:04
from public_functions import dump_file, load_file


def save_parameter_with_name(parameters, path):
    dic = {}
    for parameter in parameters:
        name = parameter.name
        value = parameter.get_value()
        shape = value.shape
        dic[name] = [shape, value]
    dump_file(dic, path)


def load_parameters(parameters, path):
    dic = load_file(path)
    for parameter in parameters:
        name = parameter.name
        value = parameter.get_value()
        shape = value.shape
        if shape != dic[name][0]:
            raise Exception('the size of '+name+'is not compatible!!')
        parameter.set_value(dic[name][1])
