# -*- coding: utf-8 -*-
import cPickle
import os
import random
import re
import string
import threading
from datetime import datetime

import itertools
import numpy as np
import sys

# import matplotlib as mpl
#
# mpl.use('Agg')
# import matplotlib.pyplot as plt

reload(sys)
sys.setdefaultencoding('utf-8')
import shutil


def rm_dir(dir_name):
    shutil.rmtree(dir_name)
    os.mkdir(dir_name)


def add2map(item, item_map):
    if item not in item_map:
        item_map[item] = len(item_map)


def plot_to_file(lst, filename):
    # plt.plot(lst)
    # plt.savefig(filename, dpi=600)
    # plt.close()
    pass


def load_word2vec(word2id):
    word2vec_path = '/home/beny/program/NMTMC/data/sct/glove.840B.300d.txt'
    vocab_size = len(word2id)
    import numpy as np
    wordEmbedding = np.float32(np.random.normal(scale=0.5, size=(vocab_size, 300)))
    number = 0
    with open(word2vec_path) as f:
        for i, line in enumerate(f):
            s = line.split(' ')
            word = s[0]
            if word in word2id:
                number += 1
                w_vecstr = np.array(s[1:300 + 1], dtype='float32')
                wordEmbedding[word2id[word]] = w_vecstr
    print number, len(word2id)
    return wordEmbedding


def find_number(string):
    pattern = re.compile(r'.*?(\d+).*')
    res = re.findall(pattern, string)
    return int(res[0])


def contain_number(string):
    pattern = re.compile(r'.*?(\d+).*')
    res = re.findall(pattern, string)
    return bool(res)


def normalize_answer(s):
    """Lower text and remove punctuation, articles and extra whitespace."""

    def remove_articles(text):
        return re.sub(r'\b(a|an|the)\b', ' ', text)

    def white_space_fix(text):
        return ' '.join(text.split())

    def remove_punc(text):
        exclude = set(string.punctuation)
        return ''.join(ch for ch in text if ch not in exclude)

    def lower(text):
        return text.lower()

    return white_space_fix(remove_articles(remove_punc(lower(s))))


def transform_id_to_string(id_list, dictMap):
    return ' '.join(map(lambda x: dictMap[x], id_list))


def transform_id_to_lst(id_list, dictMap):
    return map(lambda x: dictMap[x], id_list)


def clean_string(string):
    string = re.sub(r"[^A-Za-z0-9(),!?\']", " ", string)
    string = re.sub(r"\s{2,}", " ", string)
    return string.lower()


def reverse_dic_key_value(dic):
    return {v: k for k, v in dic.items()}


def write_list2file(list_in, filepath):
    cc = '\r\n'.join(list_in)
    with open(filepath, 'wb') as f:
        f.write(cc)


def lst_contain_subList(lst, sublst):
    n = len(sublst)
    if isinstance(sublst[0], list):
        for su_sublist in sublst:
            if lst_contain_subList(lst, su_sublist):
                return True
        return False
    else:
        return any((sublst == lst[i:i + n]) for i in xrange(len(lst) - n + 1))


def get_start_end_pos(big_list, small_list):
    n = len(big_list)
    m = len(small_list)
    start = -1
    for i in range(n - m + 1):
        if small_list == big_list[i:i + m]:
            start = i
            break
    return range(start, start + m)


def clean_word(word):
    """
    clean a word
    :param word:  like alss's
    :return: word
    """
    word = word.replace(r"n't", 'not')
    word = word.replace(r"'m", 'am')
    word = word.replace(r"'ll", 'will')
    if len(re.findall(r'(\d+)', word)) > 0:
        return "NUMBER"
    else:
        return word


def clean_str_remove(string):
    """
    Tokenization/string cleaning
    :param string: in string
    """
    string = re.sub(r"[^A-Za-z0-9(),!?\'`]", "", string)
    string = re.sub(r"\s{2,}", "", string)
    if len(re.findall(r'(\d+)', string)) > 0:
        return "NUMBER"
    return string.lower()


def clean_str(string):
    """
    Tokenization/string cleaning
    :param string: in string
    """
    string = re.sub(r"[^A-Za-z0-9(),!?\'\`]", " ", string)
    string = re.sub(r"\s{2,}", " ", string)
    return string.strip().lower()


def dump_file(obj, filepath):
    # type: (object, object) -> object
    # print 'dump file:' + filepath
    with open(filepath, 'wb') as f:
        cPickle.dump(obj, f, cPickle.HIGHEST_PROTOCOL)
        # print 'done!'


def load_file(filepath):
    # print 'load file:' + filepath
    with open(filepath, 'rb') as f:
        obj = cPickle.load(f)
    return obj


def get_txt_file_line_number(filename):
    count = 0
    the_file = open(filename, 'rb')
    while True:
        buffer = the_file.read(1024 * 8192)
        if not buffer:
            break
        count += buffer.count('\n')
    return count


import sys


def print_in_one_line(now, total, err=0.0, err2=0.0):
    b = 'Process:%-6d in total:%-6d error:%-8.4f error:%-8.4f' % (now, total, err, err2)
    # b = ("Process\t" + str(now) + " in total:" + str(
    #     total) + ' loss: ' + str(
    #     err))
    sys.stdout.write('\r' + b)


def print_in_multi_line(now, total, err=' '):
    b = ("Process\t" + str(now) + " in total:" + str(
        total) + ' loss: ' + str(
        err))
    print b


def F1_between_two_tokens(list_prediction, list_true):
    set1 = set(list_prediction)
    set2 = set(list_true)
    right = -0.000000000001
    f1 = 0.0
    if len(set1) == 0:
        return 0.0
    for one in set1:
        if one in set2:
            right += 1
    precision = right / len(set1)
    recall = right / len(set2)
    return max(2 * precision * recall / (precision + recall), f1)


def remove_duplicate_from_list(input_data):
    input_data.sort()
    return list(input_data for input_data, _ in itertools.groupby(input_data))


def padding(sequence, pads=0, max_len=None, dtype='int32', return_matrix_for_size=False):
    # we should judge the rank
    if True or isinstance(sequence[0], list):
        v_length = [len(x) for x in sequence]  # every sequence length
        seq_max_len = max(v_length)
        max_len = seq_max_len if max_len is None else max_len
        v_length = map(lambda z: z if z <= max_len else max_len, v_length)
        x = (np.ones((len(sequence), max_len)) * pads).astype(dtype)
        for idx, s in enumerate(sequence):
            trunc = s[:max_len]
            x[idx, :len(trunc)] = trunc
        if return_matrix_for_size:
            v_matrix = np.asanyarray([map(lambda item: 1 if item < line else 0, range(max_len)) for line in v_length],
                                     dtype=dtype)
            return x, v_matrix
        return x, np.asarray(v_length, dtype='int32')
    else:
        seq_len = len(sequence)
        if max_len is None:
            max_len = seq_len
        v_vector = sequence + [0] * (max_len - seq_len)
        padded_vector = np.asarray(v_vector, dtype=dtype)
        v_index = [1] * seq_len + [0] * (max_len - seq_len)
        padded_index = np.asanyarray(v_index, dtype=dtype)
        return padded_vector, padded_index


def pad_index2distribution(index, classes):
    li = [0] * classes
    li[index] = 1
    return li


def Transfer(inputs):
    return inputs


def get_list_average(input_list):
    if len(input_list) == 0:
        return 0.0
    _sum = reduce(lambda x, y: x + y, input_list, 0.0)
    return _sum / len(input_list)


def gen_yes_no_array(num_real, max_length):
    keep = [1] * num_real + [0] * (max_length - num_real)
    return np.asarray(keep, dtype=np.bool)


def get_dir_files(director):
    file_list = []
    for parent, dirnames, filenames in os.walk(director):
        for filename in filenames:
            file_list.append(os.path.join(parent, filename))
    return file_list


def is_sequence_valid(seq, ratio=0.1):
    if len(seq) < 1:
        return False
    zeros_counts = len([x for x in seq if x == 0])
    total = len(seq) + 0.0
    if zeros_counts / total > ratio:
        return False
    return True


class sort_utils(threading.Thread):
    """
    sort_map_before should be {id,list()}
    the list() is value list ,and it should be match if we sort the value
    """

    def __init__(self, sort_list_before, threads_number):
        threading.Thread.__init__(self)
        self.sort_list_before = sort_list_before
        self.length = len(sort_list_before)
        self.threads_number = threads_number
        self.sorted_list_tuple = []

    def sort_list(self):
        sorted_list_index = sorted(xrange(len(self.sort_list_before)), key=lambda k: self.sort_list_before[k])
        sorted_list = [self.sort_list_before[x] for x in sorted_list_index]
        sorted_list_tuple = []
        i = 1
        one_patch = [sorted_list_index[0]]
        while i < self.length:
            if sorted_list[i] == sorted_list[i - 1]:
                one_patch.append(sorted_list_index[i])
            else:
                sorted_list_tuple.append(one_patch)
                one_patch = [sorted_list_index[i]]
            i += 1
        sorted_list_tuple.append(one_patch)
        self.sorted_list_tuple = sorted_list_tuple

    @staticmethod
    def sort_map(sort_map_before):
        threads_number = len(sort_map_before[0])
        threads = []
        for i in xrange(threads_number):
            unsort_list = [x[i] for x in sort_map_before]
            sorter = sort_utils(unsort_list, i)
            threads.append(sorter)
            sorter.start()
        # check whether all threads done
        for thread in threads:
            while thread.is_alive():
                pass
        sorted_tuple_list = [x.sorted_list_tuple for x in threads]
        # then it is the tuple we calculate
        pass  # TODO

    def run(self):  # Overwrite run() method, put what you want the thread do here
        self.sort_list()


def random_sample(in_list):
    length = len(in_list)
    return in_list[random.randint(0, length - 1)]


def random_fetch_n_sample(random_pool, n):
    length = len(random_pool)
    random_list = shuffle_list(np.arange(length))
    return [random_pool[i] for i in random_list[0:n]]


def shuffle_list(input_list):
    c = np.copy(input_list)
    np.random.shuffle(c)
    return c


def splitParagraphIntoSentences(paragraph):
    """ break a paragraph into sentences
        and return a list """
    import re
    # to split by multile characters

    #   regular expressions are easiest (and fastest)
    sentenceEnders = re.compile(' \\. | ! | \\? ')
    sentenceList = sentenceEnders.split(paragraph)
    return sentenceList


def get_word_embedding(word2id):
    word2vec_path = '/home/beny/program/NMTMC/data/sct/glove.840B.300d.txt'
    vocab_size = len(word2id)
    print vocab_size
    wordEmbedding = np.float32(np.random.normal(scale=0.2, size=(vocab_size, 300)))
    number = 0
    with open(word2vec_path) as f:
        for i, line in enumerate(f):
            s = line.split(' ')
            word = s[0]
            if word in word2id:
                number += 1
                w_vecstr = np.array(s[1:300 + 1], dtype='float32')
                wordEmbedding[word2id[word]] = w_vecstr
    print number
    return wordEmbedding


# def dot_vectors(vec1, vec2, length):
#     vec1 = tf.transpose(tf.reshape(vec1, [1, length]))
#     vec2 = tf.reshape(vec2, [1, length])
#     res = tf.matmul(vec2, vec1)
#     return tf.gather(tf.gather(res, 0), 0)
#
#
# def tensorflow_l1_norm(input_tensor):
#     abs_value = tf.abs(input_tensor)
#     return tf.reduce_sum(abs_value)
#
#
# def tensorflow_l2_norm(input_tensor):
#     square_value = tf.square(input_tensor)
#     return tf.sqrt(tf.reduce_sum(square_value))
#

if __name__ == '__main__':
    print gen_yes_no_array(19, 40)
