# -*- coding:utf-8 -*-
# Author: Bingning Wang (王炳宁)
# Email: research@bingning.wang
# HomePage: www.bingning.wang
# Date: 2017/10/25 0025 下午 12:54
from model import *
from public_functions import *

batch_size = 32


def train_IARNN():
    model = IARNN_Gate(model_number=1989)
    [function, parameter] = model.build_model()
    data = load_file('data/WikiQACorpus/train.obj')
    total = len(data)
    print 'data size:', total
    for i in range(100):
        np.random.shuffle(data)
        for j in range(0, total, batch_size):
            batch = data[j:j + batch_size]
            questions_raw = [x[0] for x in batch]
            pos_raw = [x[1] for x in batch]
            neg_raw = [x[2] for x in batch]
            question, _ = padding(questions_raw)
            pos, _ = padding(pos_raw)
            neg, _ = padding(neg_raw)
            loss = function(question, pos, neg)
            print_in_one_line(j, i, loss)
        model.dump_function(parameter, i)


train_IARNN()
